import { world, system, EquipmentSlot } from "@minecraft/server";
import { TicksPerSecond } from "@minecraft/server";
system.runInterval(() => {
    world.getAllPlayers().filter(
        (player) => {
            const equipmentMainhand = player.getComponent("equippable");
            if (
                equipmentMainhand.getEquipment(EquipmentSlot.Mainhand)?.typeId == "trialchamberplus:heavy_sword"
            ) {
                player.addEffect("slowness", 10, { amplifier: 0, showParticles: false })
            }
            if (
                equipmentMainhand.getEquipment(EquipmentSlot.Offhand)?.typeId == "trialchamberplus:golden_sun_book"
            ) {
                player.runCommand("/particle trialchamberplus:golden_sun_book_offhand_particle ~ ~ ~");
                player.runCommand("/particle trialchamberplus:golden_sun_book_effect_offhand_particle_2 ~ ~ ~")
            }
            if (
                equipmentMainhand.getEquipment(EquipmentSlot.Offhand)?.typeId == "trialchamberplus:titanium_shield_book"
            ) {
                player.addEffect("resistance", 40, { amplifier: 0, showParticles: true });
                player.runCommand("/particle trialchamberplus:titanium_shield_particle ~ ~ ~");
            }
        }
    )
});

system.runInterval(() => {
    world.getAllPlayers().filter(
        (player) => {
            const equipmentMainhand = player.getComponent("equippable");
            if (
                equipmentMainhand.getEquipment(EquipmentSlot.Offhand)?.typeId == "trialchamberplus:golden_sun_book"
            ) {
                player.addEffect("regeneration", 150, { amplifier: 0, showParticles: true });
            }
        }
    )
}, 150);

world.afterEvents.entityHitEntity.subscribe(data => {
    let invi = data.damagingEntity.getComponent("inventory").container
    let items = invi?.getItem(data?.damagingEntity?.selectedSlotIndex)
    if (data.damagingEntity?.typeId == "minecraft:player" && items?.typeId == 'trialchamberplus:ancient_copper_sword') {
        data.hitEntity.addEffect("poison", 100, { amplifier: 0, showParticles: true })
    }
})