import { system, world, ItemStack, GameMode } from '@minecraft/server';

console.warn("working")

const itemId = [
    'trialchamberplus:fire_nova_scroll',
    'trialchamberplus:wind_charge_scroll'
];

world.beforeEvents.itemUse.subscribe(evb => {
    //Diccionario para tomar datos del Item
    const { source: player, itemStack: itemUsed } = evb;
    //Si no es un item usable entonces Return
    if (!itemUsed) return;

    //Si la Id del item esta en la variable de itemId y tiene cooldown entonces:
    if (itemId.includes(itemUsed.typeId) && !player.getItemCooldown('scroll_item_cooldown')) {

        //Si el item no es un "equippable" entonces Return
        const playerEquippableComp = player.getComponent("equippable");
        if (!playerEquippableComp) return;

        //Si el jugador esta en creativo entonces Return
        if (player.matches({ gameMode: GameMode.creative })) return;

        //Datos de la durabilidad
        const randomizeChance = Math.random() * 100;
        const itemEnchantmentComp = itemUsed.getComponent("minecraft:enchantable");
        const unbreakingLevel = itemEnchantmentComp?.getEnchantment("unbreaking")?.level ?? 0;
        const breakChance = 100 / (unbreakingLevel + 1);

        //Si breakChance es menor a randomizeChance entonces Return
        if (breakChance < randomizeChance) return;

        //Variable para tomar "durability" como dato
        const itemUsedDurabilityComp = itemUsed.getComponent("durability");

        //Si la variable itemUsedDurabilityComp es falso (osea que no tiene durabilidad) entonces Return
        if (!itemUsedDurabilityComp) return;

        //Funcion en bucle para detectar si es objeto debe romperse o tiene que recibir
        system.run(function () {
            const maxDurability = itemUsedDurabilityComp.maxDurability
            const currentDamage = itemUsedDurabilityComp.damage
            if (currentDamage >= maxDurability) {
                system.run(() => {
                    player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
                    playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
                });
            }
            else if (currentDamage < maxDurability) {
                system.run(() => {
                    itemUsedDurabilityComp.damage += 1;
                    playerEquippableComp.setEquipment("Mainhand", itemUsed);
                });
            }
        })
    }
})